searchData={"items":[{"type":"module","title":"Fixpoint.SatSolver","doc":"This module solves SAT problems represented in CNF form.\nIt's a list of lists of integers, where a positive integer `i` represents a boolean variable mapped to `i`,\nand a negative integer `j` represents negation of a boolean variable mapped to `j`.\nExamples of CNF representation:\n\n```elixir\n# x1 AND (NOT x1)\n[[1], [-1]]\n\n# x1 AND (x1 OR x2 OR x3)\n[[1], [1, 2, 3]]\n\n# x1 AND x2 AND x3\n[[1], [2], [3]]\n```","ref":"Fixpoint.SatSolver.html"},{"type":"function","title":"Fixpoint.SatSolver.check_solution/2","doc":"","ref":"Fixpoint.SatSolver.html#check_solution/2"},{"type":"function","title":"Fixpoint.SatSolver.clauses/1","doc":"","ref":"Fixpoint.SatSolver.html#clauses/1"},{"type":"function","title":"Fixpoint.SatSolver.dimacs_instances/0","doc":"","ref":"Fixpoint.SatSolver.html#dimacs_instances/0"},{"type":"function","title":"Fixpoint.SatSolver.model/1","doc":"","ref":"Fixpoint.SatSolver.html#model/1"},{"type":"function","title":"Fixpoint.SatSolver.solve/2","doc":"","ref":"Fixpoint.SatSolver.html#solve/2"},{"type":"function","title":"Fixpoint.SatSolver.to_cnf/1","doc":"","ref":"Fixpoint.SatSolver.html#to_cnf/1"},{"type":"module","title":"Fixpoint.SatSolver.VariableSelector.DLIS","doc":"Dynamic Largest Individual Sum.\n\nFor a given variable x:\n– C(x,p) – # of unresolved clauses in which x appears positively\n– C(x,n) - # of unresolved clauses in which x appears negatively\n– Let x be the literal for which C(x,p) is maximal\n– Let y be the literal for which C(y,n) is maximal\n– If C(x,p) > C(y,n) choose x and assign it TRUE\n– Otherwise choose y and assign it FALSE\n\nNote: this is equivalent to generic MostConstrained variable selector,\nexcept for the cases with both positive and negative literals for the same variable\nare in the same clause.\nThese could be just filtered out on CNF preprocessing.\nSo DLIS selector is here only to serve as a template for other variable selectors.","ref":"Fixpoint.SatSolver.VariableSelector.DLIS.html"},{"type":"function","title":"Fixpoint.SatSolver.VariableSelector.DLIS.initialize/2","doc":"","ref":"Fixpoint.SatSolver.VariableSelector.DLIS.html#initialize/2"},{"type":"function","title":"Fixpoint.SatSolver.VariableSelector.DLIS.update/2","doc":"","ref":"Fixpoint.SatSolver.VariableSelector.DLIS.html#update/2"},{"type":"module","title":"FixpointSat","doc":"Documentation for `FixpointSat`.","ref":"FixpointSat.html"},{"type":"function","title":"FixpointSat.hello/0","doc":"Hello world.","ref":"FixpointSat.html#hello/0"},{"type":"function","title":"Examples - FixpointSat.hello/0","doc":"iex> FixpointSat.hello()\n    :world","ref":"FixpointSat.html#hello/0-examples"},{"type":"extras","title":"Fixpoint SAT solver","doc":"# Fixpoint SAT solver\n\n**SAT solver for Elixir**","ref":"readme.html"},{"type":"extras","title":"Status - Fixpoint SAT solver","doc":"Proof of concept.","ref":"readme.html#status"},{"type":"extras","title":"Installation - Fixpoint SAT solver","doc":"If [available in Hex](https://hex.pm/docs/publish), the package can be installed\nby adding `fixpoint_sat` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:fixpoint_sat, \"~> 0.1.0\"}\n  ]\nend\n```\n\nDocumentation can be generated with [ExDoc](https://github.com/elixir-lang/ex_doc)\nand published on [HexDocs](https://hexdocs.pm). Once published, the docs can\nbe found at  .","ref":"readme.html#installation"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.1"}}